#include<bits/stdc++.h>

using namespace std;

int main(){
    int n;
    
    cin >> n;
    
    int niz[n], sorted[n];
    cin >> niz[0];
    sorted[0] = 1;
    for(int i = 1; i < n; i++){
        cin >> niz[i];
        sorted[i] = (niz[i] >= niz[i - 1] ? sorted[i - 1] + 1 : 1);
    }
    
    int q;
    cin >> q;
    while(q--){
        int l, r;
        bool res;
        
        cin >> l >> r;
        r--;
        l--;
        
        if(sorted[r] >= r - l + 1) res = true;
        else if(sorted[r] + sorted[r - sorted[r]] < r - l + 1) res = false;
        else {
            if(sorted[r] == 1) res = true; 
            else if(niz[r - sorted[r] + 2] >= niz[r - sorted[r]]) res = true; //izbacujemo desni
            else{                   //izbacujemo levi
                if(r - sorted[r] <= l) res = true;
                else if(niz[r - sorted[r] + 1] >= niz[r - sorted[r] - 1]) res = true;
                else res = false;
            }
        }
        
        cout << (res ? "DA" : "NE") << "\n";
    }
    
    //for(int i = 0; i < n; i++) cout << sorted[i] << " ";
    return 0;
}